# -*- coding: utf-8 -*-
#
# Copyright (c) 2021, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#

class DataTable:
    def __init__(self):
        self.headers = []
        self.lines = []

    def set_headers(self, placeholders):
        self.headers = placeholders

    def add_line(self, data_line):
        assert self.headers, "headers are not set"
        assert len(self.headers) == len(data_line), "headers and lines must have the same length"
        self.lines.append(data_line)

    def __iter__(self):
        for line in self.lines:
            yield dict(zip(self.headers, line))
