# -*- coding: utf-8 -*-
#
# Copyright (c) 2021, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#

class Feature:
    def __init__(self, name, doc, filename, line_number):
        self.name = name
        self.doc = doc
        self.filename = filename
        self.line_number = line_number
        self.scenarios = []
        self.scenario_outlines = []
        self.background = []  # list of given preconditions stated in Background:
        self.tags = None
        self.requirements = None
        self.skip_reason = None

    def add_scenario(self, scenario):
        self.scenarios.append(scenario)

    def add_scenario_outline(self, scenario_outline):
        self.scenario_outlines.append(scenario_outline)

    def set_tags(self, tags):
        self.tags = tags

    def set_requirements(self, requirements):
        self.requirements = requirements

    def set_skipped(self, reason):
        self.skip_reason = reason
