# -*- coding: utf-8 -*-
#
# Copyright (c) 2021, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#

class Scenario:
    def __init__(self, name, doc, filename, line_number, args=None, kwargs=None):
        self.name = name
        self.doc = doc
        self.rule = ""
        self.filename = filename
        self.line_number = line_number
        self.given_preconditions = list()
        self.when_conditions = list()
        self.then_assertions = list()

        # Optional parameters for data driven testing
        self.args = args
        self.kwargs = kwargs

        # Tags, requirements and skip reasons
        self.tags = None
        self.requirements = None
        self.skip_reason = None

    def add_given(self, step):
        self.given_preconditions.append(step)

    def add_when(self, step):
        self.when_conditions.append(step)

    def add_then(self, step):
        self.then_assertions.append(step)

    def set_tags(self, tags):
        self.tags = tags

    def set_requirements(self, requirements):
        self.requirements = requirements

    def set_skipped(self, reason):
        self.skip_reason = reason
