# -*- coding: utf-8 -*-
#
# Copyright (c) 2021, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#

import re

_tags_pattern = re.compile(r'^[a-zA-Z0-9_\-\.]+$')


def tags(*tags):
    """
    Tag a test or class.

    Args:
        *tags: the tags to be used
    """
    for tag in tags:
        if not _tags_pattern.match(tag):
            raise Exception(r"tag must match regular expression '^[a-zA-Z0-9_\-\.]+$'")

    def tagger(tagged):
        # tag a method or class
        if not hasattr(tagged, "_htf_tags"):
            tagged._htf_tags = set()
        tagged._htf_tags = tagged._htf_tags | set(tags)

        return tagged
    return tagger
